Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2232)
@@ -3733,152 +4502,198 @@
             ENDDO
         ENDDO
-        
-!--     assign the surface types to local surface array
-        DO  l = startenergy, endenergy
-            
-            d = surfl(id,l)
-            kw = surfl(iz,l)
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-            IF ( d == iroof )  THEN
-!--             horizontal surface - land or roof
-                iw = i
-                jw = j
-                IF ( usm_par(5,jw,iw) == 0 )  THEN
-                    IF ( zu(kw) >= roof_height_limit )  THEN
-                        isroof_surf(l) = .TRUE.
-                        surface_types(l) = roof_category         !< default category for root surface
-                    ELSE
-                        isroof_surf(l) = .FALSE.
-                        surface_types(l) = land_category         !< default category for land surface
-                    ENDIF
-                    albedo_surf(l) = -1.0_wp
-                    thickness_wall(l) = -1.0_wp
-                ELSE
-                    IF ( usm_par(2,jw,iw)==0 )  THEN
-                        isroof_surf(l) = .FALSE.
-                        thickness_wall(l) = -1.0_wp
-                    ELSE
-                        isroof_surf(l) = .TRUE.
-                        thickness_wall(l) = usm_val(2,jw,iw)
-                    ENDIF
-                    surface_types(l) = usm_par(5,jw,iw)
-                    albedo_surf(l) = usm_val(1,jw,iw)
-                ENDIF
-            ELSE
-                SELECT CASE (d)
-                    CASE (iwest)
-                        iw = i
-                        jw = j
-                        ii = 6
-                        ij = 3
-                    CASE (ieast)
-                        iw = i-1
-                        jw = j
-                        ii = 6
-                        ij = 3
-                    CASE (isouth)
-                        iw = i
-                        jw = j
-                        ii = 12
-                        ij = 9
-                    CASE (inorth)
-                        iw = i
-                        jw = j-1
-                        ii = 12
-                        ij = 9
-                END SELECT
-                
-                IF ( kw <= usm_par(ii,jw,iw) )  THEN
-!--                 pedestrant zone
-                    isroof_surf(l) = .FALSE.
-                    IF ( usm_par(ii+1,jw,iw) == 0 )  THEN
-                        surface_types(l) = pedestrant_category   !< default category for wall surface in pedestrant zone
-                        albedo_surf(l) = -1.0_wp
-                        thickness_wall(l) = -1.0_wp
-                    ELSE
-                        surface_types(l) = usm_par(ii+1,jw,iw)
-                        albedo_surf(l) = usm_val(ij,jw,iw)
-                        thickness_wall(l) = usm_val(ij+1,jw,iw)
-                    ENDIF
-                ELSE IF ( kw <= usm_par(ii+2,jw,iw) )  THEN
-!--                 wall zone
-                    isroof_surf(l) = .FALSE.
-                    IF ( usm_par(ii+3,jw,iw) == 0 )  THEN
-                        surface_types(l) = wall_category         !< default category for wall surface
-                        albedo_surf(l) = -1.0_wp
-                        thickness_wall(l) = -1.0_wp
-                    ELSE
-                        surface_types(l) = usm_par(ii+3,jw,iw)
-                        albedo_surf(l) = usm_val(ij+2,jw,iw)
-                        thickness_wall(l) = usm_val(ij+3,jw,iw)
-                    ENDIF
-                ELSE IF ( kw <= usm_par(ii+4,jw,iw) )  THEN
-!--                 roof zone
-                    isroof_surf(l) = .TRUE.
-                    IF ( usm_par(ii+5,jw,iw) == 0 )  THEN
-                        surface_types(l) = roof_category         !< default category for roof surface
-                        albedo_surf(l) = -1.0_wp
-                        thickness_wall(l) = -1.0_wp
-                    ELSE
-                        surface_types(l) = usm_par(ii+5,jw,iw)
-                        albedo_surf(l) = usm_val(ij+4,jw,iw)
-                        thickness_wall(l) = usm_val(ij+5,jw,iw)
-                    ENDIF
-                ELSE
-!--                 something wrong
-                    CALL message( 'usm_read_urban_surface', 'PA0505', 1, 2, 0, 6, 0 )
-                ENDIF
-            ENDIF
-            
-!--         find the type position
-            it = surface_types(l)
-            ip = -99999
-            DO k = 1, n_surface_types
-                IF ( surface_type_codes(k) == it )  THEN
+!        
+!--     Assign the surface types to the respective data type. 
+!--     First, for horizontal upward-facing surfaces. 
+        DO  m = 1, surf_usm_h%ns
+           iw = surf_usm_h%i(m)
+           jw = surf_usm_h%j(m)
+           kw = surf_usm_h%k(m)
+
+           IF ( usm_par(5,jw,iw) == 0 )  THEN
+              IF ( zu(kw) >= roof_height_limit )  THEN
+                 surf_usm_h%isroof_surf(m)   = .TRUE.
+                 surf_usm_h%surface_types(m) = roof_category         !< default category for root surface
+              ELSE
+                 surf_usm_h%isroof_surf(m)   = .FALSE.
+                 surf_usm_h%surface_types(m) = land_category         !< default category for land surface
+              ENDIF
+              surf_usm_h%albedo_surf(m)    = -1.0_wp
+              surf_usm_h%thickness_wall(m) = -1.0_wp
+           ELSE
+              IF ( usm_par(2,jw,iw)==0 )  THEN
+                 surf_usm_h%isroof_surf(m)    = .FALSE.
+                 surf_usm_h%thickness_wall(m) = -1.0_wp
+              ELSE
+                 surf_usm_h%isroof_surf(m)    = .TRUE.
+                 surf_usm_h%thickness_wall(m) = usm_val(2,jw,iw)
+              ENDIF
+              surf_usm_h%surface_types(m) = usm_par(5,jw,iw)
+              surf_usm_h%albedo_surf(m)   = usm_val(1,jw,iw)
+           ENDIF
+!
+!--        Find the type position
+           it = surf_usm_h%surface_types(m)
+           ip = -99999
+           DO k = 1, n_surface_types
+              IF ( surface_type_codes(k) == it )  THEN
+                 ip = k
+                 EXIT
+              ENDIF
+           ENDDO
+           IF ( ip == -99999 )  THEN
+!--           wall category not found
+              WRITE (message_string, "(A,I5,A,3I5)") 'wall category ', it,     &
+                                     ' not found  for i,j,k=', iw,jw,kw
+              CALL message( 'usm_read_urban_surface', 'PA0506', 1, 2, 0, 6, 0 )
+           ENDIF
+!
+!--        Albedo
+           IF ( surf_usm_h%albedo_surf(m) < 0.0_wp )  THEN
+              surf_usm_h%albedo_surf(m) = surface_params(ialbedo,ip)
+           ENDIF
+!
+!--        emissivity of the wall
+           surf_usm_h%emiss_surf(m) = surface_params(iemiss,ip)
+!            
+!--        heat conductivity Î»S between air and wall ( W mâ2 Kâ1 )
+           surf_usm_h%lambda_surf(m) = surface_params(ilambdas,ip)
+!            
+!--        roughness relative to concrete
+           surf_usm_h%roughness_wall(m) = surface_params(irough,ip)
+!            
+!--        Surface skin layer heat capacity (J mâ2 Kâ1 )
+           surf_usm_h%c_surface(m) = surface_params(icsurf,ip)
+!            
+!--        wall material parameters:
+!--        thickness of the wall (m)
+!--        missing values are replaced by default value for category
+           IF ( surf_usm_h%thickness_wall(m) <= 0.001_wp )  THEN
+                surf_usm_h%thickness_wall(m) = surface_params(ithick,ip)
+           ENDIF
+!            
+!--        volumetric heat capacity rho*C of the wall ( J mâ3 Kâ1 )
+           surf_usm_h%rho_c_wall(:,m) = surface_params(irhoC,ip)
+!            
+!--        thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
+           surf_usm_h%lambda_h(:,m) = surface_params(ilambdah,ip)
+
+        ENDDO
+!
+!--     For vertical surface elements ( 0 -- northward-facing, 1 -- southward-facing,
+!--     2 -- eastward-facing, 3 -- westward-facing )
+        DO  l = 0, 3
+           DO  m = 1, surf_usm_v(l)%ns
+              i  = surf_usm_v(l)%i(m)
+              j  = surf_usm_v(l)%j(m)
+              kw = surf_usm_v(l)%k(m)
+
+              IF ( l == 3 )  THEN ! westward facing
+                 iw = i
+                 jw = j
+                 ii = 6
+                 ij = 3
+              ELSEIF ( l == 2 )  THEN
+                 iw = i-1
+                 jw = j
+                 ii = 6
+                 ij = 3
+              ELSEIF ( l == 1 )  THEN
+                 iw = i
+                 jw = j
+                 ii = 12
+                 ij = 9
+              ELSEIF ( l == 0 )  THEN
+                 iw = i
+                 jw = j-1
+                 ii = 12
+                 ij = 9
+              ENDIF
+
+              IF ( kw <= usm_par(ii,jw,iw) )  THEN
+!--              pedestrant zone
+                 IF ( usm_par(ii+1,jw,iw) == 0 )  THEN
+                     surf_usm_v(l)%surface_types(m)  = pedestrant_category   !< default category for wall surface in pedestrant zone
+                     surf_usm_v(l)%albedo_surf(m)    = -1.0_wp
+                     surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                 ELSE
+                     surf_usm_v(l)%surface_types(m)  = usm_par(ii+1,jw,iw)
+                     surf_usm_v(l)%albedo_surf(m)    = usm_val(ij,jw,iw)
+                     surf_usm_v(l)%thickness_wall(m) = usm_val(ij+1,jw,iw)
+                 ENDIF
+              ELSE IF ( kw <= usm_par(ii+2,jw,iw) )  THEN
+!--              wall zone
+                 IF ( usm_par(ii+3,jw,iw) == 0 )  THEN
+                     surf_usm_v(l)%surface_types(m)  = wall_category         !< default category for wall surface
+                     surf_usm_v(l)%albedo_surf(m)    = -1.0_wp
+                     surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                 ELSE
+                     surf_usm_v(l)%surface_types(m)  = usm_par(ii+3,jw,iw)
+                     surf_usm_v(l)%albedo_surf(m)    = usm_val(ij+2,jw,iw)
+                     surf_usm_v(l)%thickness_wall(m) = usm_val(ij+3,jw,iw)
+                 ENDIF
+              ELSE IF ( kw <= usm_par(ii+4,jw,iw) )  THEN
+!--              roof zone
+                 IF ( usm_par(ii+5,jw,iw) == 0 )  THEN
+                     surf_usm_v(l)%surface_types(m)  = roof_category         !< default category for roof surface
+                     surf_usm_v(l)%albedo_surf(m)    = -1.0_wp
+                     surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                 ELSE
+                     surf_usm_v(l)%surface_types(m)  = usm_par(ii+5,jw,iw)
+                     surf_usm_v(l)%albedo_surf(m)    = usm_val(ij+4,jw,iw)
+                     surf_usm_v(l)%thickness_wall(m) = usm_val(ij+5,jw,iw)
+                 ENDIF
+              ELSE
+!--              something wrong
+                 CALL message( 'usm_read_urban_surface', 'PA0505', 1, 2, 0, 6, 0 )
+              ENDIF
+
+!
+!--           Find the type position
+              it = surf_usm_v(l)%surface_types(m)
+              ip = -99999
+              DO k = 1, n_surface_types
+                 IF ( surface_type_codes(k) == it )  THEN
                     ip = k
                     EXIT
-                ENDIF
-            ENDDO
-            IF ( ip == -99999 )  THEN
-!--             wall category not found
-                WRITE (message_string, "(A,I5,A,3I5)") 'wall category ', it, ' not found  for i,j,k=', iw,jw,kw
-                CALL message( 'usm_read_urban_surface', 'PA0506', 1, 2, 0, 6, 0 )
-            ENDIF
-            
-!--         Fill out the parameters of the wall
-!--         wall surface:
-            
-!--         albedo
-            IF ( albedo_surf(l) < 0.0_wp )  THEN
-                albedo_surf(l) = surface_params(ialbedo, ip)
-            ENDIF
-            
-!--         emissivity of the wall
-            emiss_surf(l) = surface_params(iemiss, ip)
-            
-!--         heat conductivity Î»S between air and wall ( W mâ2 Kâ1 )
-            lambda_surf(l) = surface_params(ilambdas, ip)
-            
-!--         roughness relative to concrete
-            roughness_wall(l) = surface_params(irough, ip)
-            
-!--         Surface skin layer heat capacity (J mâ2 Kâ1 )
-            c_surface(l) = surface_params(icsurf, ip)
-            
-!--         wall material parameters:
-            
-!--         thickness of the wall (m)
-!--         missing values are replaced by default value for category
-            IF ( thickness_wall(l) <= 0.001_wp )  THEN
-                thickness_wall(l) = surface_params(ithick, ip)
-            ENDIF
-            
-!--         volumetric heat capacity rho*C of the wall ( J mâ3 Kâ1 )
-            rho_c_wall(:,l) = surface_params(irhoC, ip)
-            
-!--         thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
-            lambda_h(:,l) = surface_params(ilambdah, ip)
-            
+                 ENDIF
+              ENDDO
+              IF ( ip == -99999 )  THEN
+!--              wall category not found
+                 WRITE (message_string, "(A,I5,A,3I5)") 'wall category ', it,  &
+                                        ' not found  for i,j,k=', iw,jw,kw
+                 CALL message( 'usm_read_urban_surface', 'PA0506', 1, 2, 0, 6, 0 )
+              ENDIF
+!
+!--           Albedo
+              IF ( surf_usm_v(l)%albedo_surf(m) < 0.0_wp )  THEN
+                 surf_usm_v(l)%albedo_surf(m) = surface_params(ialbedo,ip)
+              ENDIF
+!
+!--           emissivity of the wall
+              surf_usm_v(l)%emiss_surf(m) = surface_params(iemiss,ip)
+!            
+!--           heat conductivity Î»S between air and wall ( W mâ2 Kâ1 )
+              surf_usm_v(l)%lambda_surf(m) = surface_params(ilambdas,ip)
+!            
+!--           roughness relative to concrete
+              surf_usm_v(l)%roughness_wall(m) = surface_params(irough,ip)
+!            
+!--           Surface skin layer heat capacity (J mâ2 Kâ1 )
+              surf_usm_v(l)%c_surface(m) = surface_params(icsurf,ip)
+!            
+!--           wall material parameters:
+!--           thickness of the wall (m)
+!--           missing values are replaced by default value for category
+              IF ( surf_usm_v(l)%thickness_wall(m) <= 0.001_wp )  THEN
+                   surf_usm_v(l)%thickness_wall(m) = surface_params(ithick,ip)
+              ENDIF
+!            
+!--           volumetric heat capacity rho*C of the wall ( J mâ3 Kâ1 )
+              surf_usm_v(l)%rho_c_wall(:,m) = surface_params(irhoC,ip)
+!            
+!--           thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
+              surf_usm_v(l)%lambda_h(:,m) = surface_params(ilambdah,ip)
+
+           ENDDO
         ENDDO
 
@@ -3900,5 +4715,5 @@
         IMPLICIT NONE
 
-        INTEGER(iwp)                          :: i, j, k, l, d      !< running indices
+        INTEGER(iwp)                          :: i, j, k, l, d, m   !< running indices
         
         REAL(wp)                              :: pt1                !< temperature at first grid box adjacent to surface
